package htdinc.howtodrink.Repository;

import android.content.Context;
import android.database.Cursor;
import android.location.Location;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import htdinc.howtodrink.DataBase.DataBaseOpenHelper;
import htdinc.howtodrink.Objects.Bar;

/**
 * Created by Rudy on 31/05/2016.
 */
public class BarRepository extends Repository{

    public BarRepository(Context context) {
        sqLiteOpenHelper = new DataBaseOpenHelper(context);
    }

    public List GetAllByName(String nameBar) {

        String whereClause = DataBaseOpenHelper.COLUMN_NAMEBAR + " LIKE ?";

        Cursor cursor = myDatabase.query(DataBaseOpenHelper.BAR_TABLE_NAME,
                new String[]{DataBaseOpenHelper.COLUMN_IDBAR,
                        DataBaseOpenHelper.COLUMN_NAMEBAR,
                        DataBaseOpenHelper.COLUMN_NOTEBAR,
                        DataBaseOpenHelper.COLUMN_ADDRESSBAR,
                        DataBaseOpenHelper.COLUMN_GPSLOCATIONLATITUDEBAR,
                        DataBaseOpenHelper.COLUMN_GPSLOCATIONLONGITUDEBAR}, whereClause, new String[]{String.valueOf(nameBar)}, null,
                null, null);

        return ConvertCursorToListObject(cursor);
    }

    @Override
    public List GetAll() {

        Cursor cursor = myDatabase.query(DataBaseOpenHelper.BAR_TABLE_NAME,
                new String[]{DataBaseOpenHelper.COLUMN_IDBAR,
                        DataBaseOpenHelper.COLUMN_NAMEBAR,
                        DataBaseOpenHelper.COLUMN_NOTEBAR,
                        DataBaseOpenHelper.COLUMN_ADDRESSBAR,
                        DataBaseOpenHelper.COLUMN_GPSLOCATIONLATITUDEBAR,
                        DataBaseOpenHelper.COLUMN_GPSLOCATIONLONGITUDEBAR}, null, null, null,
                null, null);

        return ConvertCursorToListObject(cursor);
    }

    @Override
    public Object GetById(int id) {
        return null;
    }

    @Override
    public void Save(Object entite) {

    }

    @Override
    public void Update(Object obj) {

    }

    @Override
    public void Delete(int id) {

    }

    @Override
    public List ConvertCursorToListObject(Cursor c) {
        ArrayList<Bar> liste = new ArrayList<>();

        // Si la liste est vide
        if (c.getCount() == 0)
            return liste;

        // position sur le premeir item
        c.moveToFirst();

        // Pour chaque item
        do {

            Bar bar = ConvertCursorToObject(c);

            liste.add(bar);
        } while (c.moveToNext());

        // Fermeture du curseur
        c.close();

        return liste;
    }

    @Override
    public Bar ConvertCursorToObject(Cursor c) {

        Bar bar = new Bar(c.getInt(DataBaseOpenHelper.NUM_COLUMN_IDBAR),
                c.getString(DataBaseOpenHelper.NUM_COLUMN_NAMEBAR),
                c.getFloat(DataBaseOpenHelper.NUM_COLUMN_NOTEBAR),
                c.getString(DataBaseOpenHelper.NUM_COLUMN_ADDRESSBAR),
                c.getDouble(DataBaseOpenHelper.NUM_COLUMN_GPSLOCATIONLATITUDEBAR),
                c.getDouble(DataBaseOpenHelper.NUM_COLUMN_GPSLOCATIONLONGITUDEBAR));

        return bar;
    }

    @Override
    public Bar ConvertCursorToOneObject(Cursor c) {
        c.moveToFirst();

        Bar bar = ConvertCursorToObject(c);

        c.close();
        return bar;
    }
}
